"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _CalendarView = _interopRequireDefault(require("./CalendarView"));

var _dates = _interopRequireDefault(require("./util/dates"));

var _ = require("./util/_");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var propTypes = {
  today: _propTypes.default.instanceOf(Date),
  value: _propTypes.default.instanceOf(Date),
  focusedItem: _propTypes.default.instanceOf(Date),
  min: _propTypes.default.instanceOf(Date),
  max: _propTypes.default.instanceOf(Date),
  onChange: _propTypes.default.func.isRequired,
  localizer: _propTypes.default.object.isRequired,
  disabled: _propTypes.default.bool
};

function CenturyView(_ref) {
  var focusedItem = _ref.focusedItem,
      disabled = _ref.disabled,
      onChange = _ref.onChange,
      value = _ref.value,
      today = _ref.today,
      localizer = _ref.localizer,
      min = _ref.min,
      max = _ref.max,
      props = _objectWithoutPropertiesLoose(_ref, ["focusedItem", "disabled", "onChange", "value", "today", "localizer", "min", "max"]);

  var chunks = (0, _react.useMemo)(function () {
    return (0, _.chunk)(getCenturyDecades(focusedItem), 4);
  }, [focusedItem]);
  return _react.default.createElement(_CalendarView.default, _extends({}, props, {
    focusedItem: focusedItem,
    onChange: onChange
  }), _react.default.createElement(_CalendarView.default.Body, null, chunks.map(function (row, rowIdx) {
    return _react.default.createElement(_CalendarView.default.Row, {
      key: rowIdx
    }, row.map(function (date, colIdx) {
      var label = localizer.formatDate(_dates.default.startOf(date, 'decade'), 'decade');
      return _react.default.createElement(_CalendarView.default.Cell, {
        key: colIdx,
        unit: "decade",
        label: label,
        date: date,
        now: today,
        min: min,
        max: max,
        onChange: onChange,
        focusedItem: focusedItem,
        selected: value,
        disabled: disabled
      }, label);
    }));
  })));
}

CenturyView.propTypes = propTypes;

function getCenturyDecades(_date) {
  var days = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12],
      date = _dates.default.add(_dates.default.startOf(_date, 'century'), -20, 'year');

  return days.map(function () {
    return date = _dates.default.add(date, 10, 'year');
  });
}

var _default = CenturyView;
exports.default = _default;
module.exports = exports["default"];