"use strict";

exports.__esModule = true;
exports.default = allowCreate;

function allowCreate(allowCreate, _ref) {
  var searchTerm = _ref.searchTerm,
      caseSensitive = _ref.caseSensitive,
      data = _ref.data,
      dataItems = _ref.dataItems,
      accessors = _ref.accessors;

  var hasExtactMatch = function hasExtactMatch() {
    var lower = function lower(text) {
      return caseSensitive ? text : text.toLowerCase();
    };

    var eq = function eq(v) {
      return lower(accessors.text(v)) === lower(searchTerm);
    }; // if there is an exact match on textFields:
    // "john" => { name: "john" }, don't show


    return (dataItems === null || dataItems === void 0 ? void 0 : dataItems.some(eq)) || data.some(eq);
  };

  return !!((allowCreate === true || allowCreate === 'onFilter' && searchTerm) && !hasExtactMatch());
}

module.exports = exports["default"];