"use strict";

exports.__esModule = true;
exports.notify = notify;
exports.useFirstFocusedRender = useFirstFocusedRender;
exports.useInstanceId = void 0;

var _react = require("react");

var idCount = 0;

function uniqueId(prefix) {
  return '' + ((prefix == null ? '' : prefix) + ++idCount);
}

function notify(handler, args) {
  // eslint-disable-next-line babel/no-unused-expressions
  handler && handler.apply(null, [].concat(args));
}

var useInstanceId = function useInstanceId(otherId, suffix) {
  if (suffix === void 0) {
    suffix = '';
  }

  var id = (0, _react.useRef)(null);
  if (!id.current) id.current = uniqueId('rw_');
  return (otherId || id.current) + suffix;
};
/**
 * Allows for defering popup rendering untill the widget is focused,
 * or has been opened (in order to not remove it suddenly on close)
 */


exports.useInstanceId = useInstanceId;

function useFirstFocusedRender(focused, open) {
  var ref = (0, _react.useRef)(false);
  return ref.current || (focused || !!open) && (ref.current = true);
}